using System;
using System.Threading;

namespace Parkeringshus_wait_notify
{
	public class P_Hus_Monitor
	{
		private int antalBiler; // biler i huset
		private int pladser;	// antal parkeringspladser

		public P_Hus_Monitor(int pladser)
		{
			this.pladser = pladser;
			antalBiler = 0;
		}
		public void bilKrerInd() 
		{
			System.Console.WriteLine("Start p bilKrerInd");
			{
				Monitor.Enter(this);
				while (antalBiler == pladser)
				{
					System.Console.WriteLine("Parkeringshus fuldt - ingen indkrsler nu");
					Monitor.PulseAll(this);
					Monitor.Wait(this);
				}

				antalBiler++;
				System.Console.WriteLine("Bil krer ind - der er nu ialt:"+antalBiler+" biler");

				if (antalBiler == 1)
				{
					System.Console.WriteLine("ben for udkrsler igen - 1. bil lige krt ind");
					Monitor.PulseAll(this);
					Monitor.Exit(this);
				}
			}
		}

		public void bilKrerUd()
		{
			System.Console.WriteLine("Start p bilKrerUd");
			Monitor.Enter(this);
			System.Console.WriteLine("Start p bilKrerUd Enter");
		{
				while (antalBiler == 0)
				{
					System.Console.WriteLine("Parkeringshus tomt - ingen udkrsler nu");
					Monitor.PulseAll(this);
					Monitor.Wait(this);
				}

				antalBiler--;
				System.Console.WriteLine("Bil krer ud - der er nu ialt:"+antalBiler+" biler");

				if (antalBiler == pladser-1)
				{
					System.Console.WriteLine("ben for indkrsler igen - sidste plads  lige blevet ledig");
					Monitor.PulseAll(this);
					Monitor.Exit(this);
				}
			}
		}
	}
}
